/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package jewels;

import java.io.File;
import javafx.animation.KeyFrame;
import javafx.animation.Timeline;
import javafx.application.Application;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.Scene;
import javafx.scene.canvas.Canvas;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.input.MouseEvent;
import javafx.scene.layout.StackPane;
import javafx.stage.FileChooser;
import javafx.stage.FileChooser.ExtensionFilter;
import javafx.stage.Stage;
import javafx.util.Duration;
import jewels.MyPoint;

/**
 *
 * @author soutez506
 */
public class Jewels extends Application {
    private Drawing drw = new Drawing();
    Game gm = new Game();
    
    private TimeDialog dialog = new TimeDialog();
    
    
    
    @Override
    public void start(Stage primaryStage) {
        
        StackPane root = new StackPane();
        Scene scene = new Scene(root, 500, 620);
        primaryStage.setTitle("Snake");
        Canvas canvas = new Canvas(scene.getWidth(), scene.getHeight());
        final GraphicsContext gc = canvas.getGraphicsContext2D();
        
        
        
        FileChooser fileChooser = new FileChooser();
        fileChooser.setTitle("Open Resource File");
        fileChooser.getExtensionFilters().addAll(
            new ExtensionFilter("Text Files", "*.txt"),
            new ExtensionFilter("All Files", "*.*"));
        File selectedFile = fileChooser.showOpenDialog(primaryStage);
        gm.openFile(selectedFile.getPath());
        dialog.showDialog(primaryStage);
        drw.setNewTime(dialog.getValue());
        System.out.println(dialog.getValue()); 
        
        drw.drawBG(gc);
        drw.drawStones(gc, gm.getStones());
        drw.drawNext(gc, gm.getNext());
        drw.drawPanel(gc, gm.getScore());
        
        
        //nastavení timeru
        Timeline timer = new Timeline(new KeyFrame(Duration.millis(1000), (ActionEvent event) -> {
            
            drw.setTime();
               drw.drawPanel(gc, gm.getScore());
        }));
        timer.setCycleCount(Timeline.INDEFINITE);
        timer.play();
        
        //kliknutí
        canvas.addEventHandler(MouseEvent.MOUSE_CLICKED, 
        new EventHandler<MouseEvent>() 
        {
            int x;
            int y; 
            MyPoint tmp = new MyPoint(-1, -1);
            
            @Override
            public void handle(MouseEvent e) 
            {
                x = (int)((e.getX() - 50)/50);
                y = (int)((e.getY() - 200)/50);
                
                if (x >=0 && y >= 0){
                    if (tmp.getX() != -1 && (Math.abs(tmp.getX() - x) == 1 || Math.abs(tmp.getY() - y) == 1)){
                        gm.change(tmp, new MyPoint(x, y));
                        drw.drawBG(gc);
                        drw.drawStones(gc, gm.getStones());
                        drw.drawNext(gc, gm.getNext());
                        drw.drawPanel(gc, gm.getScore());
                        tmp = new MyPoint(-1, -1);
                    }
                    else{                    
                        tmp = new MyPoint(x, y);
                        drw.drawStones(gc, gm.getStones());
                        drw.drowSelect(gc, x, y);
                    }
                }
            }
            
        });
        
        root.getChildren().add(canvas);        
        primaryStage.setTitle("Jewels");
        primaryStage.setScene(scene);
        primaryStage.show();
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        launch(args);
    }
    
}
